cordova.define("com.lampa.startapp.startapp", function(require, exports, module) {
/**
	com.lampa.startapp, ver. 6.1.4
	https://github.com/lampaa/com.lampa.startapp
	
	Phonegap plugin for check or launch other application in android device (iOS support).
	bug tracker: https://github.com/lampaa/com.lampa.startapp/issues
*/

var exec = require('cordova/exec');
module.exports = {
	/** 
	 * Set application params
	 *
	 * @param {Mixed} params				params, view documentation https://github.com/lampaa/com.lampa.startapp
	 * @param {Mixed} extra   				Extra fields
	 * @param {Function} errorCallback		The callback that is called when an error occurred when the program starts.
	 *
	 */
	 TYPE:{
	 	S_QQ:{code:"mqq:",name:"QQ"},
	 	S_WEIXIN:{code:"weixin:",name:"微信"},
	 	S_TAOBAO:{code:"taobap:",name:"淘宝"},
	 	S_DIANPING:{code:"dianping:",name:"点评"},
	 	S_SINAWEIBO:{code:"sinaweibo:",name:"微博"},
	 	S_WEICO:{code:"weico:",name:"weico微博"},
	 	S_ALIPAY:{code:"alipay:",name:"支付宝"},
	 	S_DOUBAN:{code:"fm：doubanradio:",name:"豆瓣fm"},
	 	S_SINAVDISK:{code:"sinavdisk:",name:"微盘"},
	 	S_NTESOPEN:{code:"ntesopen:",name:"网易公开课"},
	 	S_IMETITUAN:{code:"imeituan:",name:"美团"},
	 	S_JDMOBLE:{code:"openapp.jdmoble:",name:"京东"},
	 	S_RENREN:{code:"renren:",name:"人人"},
	 	S_WCC:{code:"wcc:",name:"我查查"},
	 	S_WCCBYIHAODIAN:{code:"wccbyihaodian:",name:"1号店"},
	 	S_YDDICTPROAPP:{code:"yddictproapp:",name:"有道词典"},
	 	S_ZHIHU:{code:"zhihu:",name:"知乎"},
	 	S_YOUKU:{code:"youku:",name:"优酷"},
	 	S_BAIDUMAP:{code:"baidumap:",name:"百度地图"},
	 	S_iosamap:{code:"iosamap:",name:"高德地图"}
	 },
	
	set: function(params, extra) {
		var output = [params];
			
		if(extra != undefined) {
			output.push(extra);
		}
		else {
			output.push(null);
		}
		
		return {
			
			
			start: function(completeCallback, errorCallback, messageCallback) {
				completeCallback = completeCallback || function() {};
				errorCallback = errorCallback || function() {};
				messageCallback = messageCallback || function() {};
				
				exec(function(result) {
				    if(result === "OK") {
				        completeCallback(result);
				    }
				    else {
				        var requestCode = result["_ACTION_requestCode_"];
				        delete result["_ACTION_requestCode_"];

				        var resultCode = result["_ACTION_resultCode_"];
				        delete result["_ACTION_resultCode_"];

				        messageCallback(result, requestCode, resultCode);
				    }
				}, errorCallback, "startApp", "start", output);
			},
			check: function(completeCallback, errorCallback) {
				completeCallback = completeCallback || function() {};
				errorCallback = errorCallback || function() {};
				
				exec(completeCallback, errorCallback, "startApp", "check", output);
			},
			receiver: function(completeCallback, errorCallback, messageCallback) {
				completeCallback = completeCallback || function() {};
				errorCallback = errorCallback || function() {};
				messageCallback = messageCallback || function() {};

				exec(function(result) {
				    if(/\d+/.test(result)) {
				        completeCallback(result);
				    }
				    else {
				        var action = result["_ACTION_VALUE_FORMAT_"];
				        delete result["_ACTION_VALUE_FORMAT_"];

				        messageCallback(action, result);
				    }
				}, errorCallback, "startApp", "receiver", output);
			}
		}
	},
	/**
	 * extra values
	 */
	getExtras: function(completeCallback, errorCallback) {
		exec(completeCallback, errorCallback, "startApp", "getExtras", []);
	},
	getExtra: function(extraValue, completeCallback, errorCallback) {
		exec(completeCallback, errorCallback, "startApp", "getExtra", [extraValue]);
	},
	hasExtra: function(extraValue, completeCallback, errorCallback) {
		this.getExtra(extraValue, completeCallback, errorCallback);
	}
}

});
